#!/usr/local/bin/perl5 -w

# This script aggregates the values in a recorded action_compare log file from
# the coach

$usage = "$0 <mincnt> [<datafn>]";

$min_cnt = shift @ARGV;
#$too_small_cnt = 50;

die $usage if (not defined($min_cnt));

print "# This file was modified by agg_comp_action.pl to aggregate/smooth the data\n";

$curr_time = -1;
$curr_cnt = 0;
$curr_perc = 0.0;

while (<>) {
  $saveline = $_;
  s/\#.*//;
  if (/^\s*$/) {
    print $saveline;
    next;
  }
  ($time, $cnt, $perc) = split;

  #&shipout if ($cnt < $too_small_cnt);

  next if ($cnt == 0);

  $curr_time = $time;
  $curr_perc = ($curr_cnt * $curr_perc + $cnt * $perc) / ($curr_cnt + $cnt);
  $curr_cnt += $cnt;

  #&shipout if ($cnt < $too_small_cnt || $curr_cnt > $min_cnt);
  &shipout if ($curr_cnt > $min_cnt);
}


sub shipout {
  return if ($curr_cnt <= 0);
  print "$curr_time $curr_cnt $curr_perc\n";
  $curr_time = -1;
  $curr_cnt = 0;
  $curr_perc = 0.0;
}
