#!/usr/local/bin/perl5 -w

# This script aggregates the values in a policy evaluation file

use File::Basename;
$usage = "$0 <lines to agg> <datafn> [<outfn>]";

$lines_to_agg = shift @ARGV;
$datafn = shift @ARGV;
$outfn = shift @ARGV;
#$too_small_cnt = 50;

die $usage if (not (defined($lines_to_agg) && defined($datafn)));

if (not defined($outfn)) {
  $outfn = dirname($datafn) . '/' . "agg${lines_to_agg}_" . basename($datafn);
}

open (INFH, "<$datafn") || die "Could not open data file '$datafn': $!";
open (OUTFH, ">$outfn") || die "Could not open out file '$outfn': $!";

print OUTFH "# This file was modified by $0 to aggregate/smooth the data\n";

$curr_time = -1;
$curr_value = 0;
$curr_cnt = 0;

while (<INFH>) {
  $saveline = $_;
  s/\#.*//;
  if (/^\s*$/) {
    print OUTFH $saveline;
    next;
  }
  ($time, $value) = split;

  $curr_time = $time;
  $curr_value = ($curr_cnt * $curr_value + $value) / ($curr_cnt + 1);
  $curr_cnt++;

  &shipout if ($curr_cnt >= $lines_to_agg);
}


sub shipout {
  return if ($curr_cnt <= 0);
  print OUTFH "$curr_time $curr_value\n";
  $curr_time = -1;
  $curr_value = 0;
  $curr_cnt = 0;
}
