#!/usr/local/bin/perl5 -w

# this script reads in a avg reward file and changes the scale at which the rewards are considered
# giving 0 averages the whole thing
# there is some "bleeding" around the edges of this thing because of the ultra simple combine alg I use
# therefore, don't use this for reporting official results unless your interval is a multiple
# of the interval in the actual file

$usage = "$0 <desired_int> [<reward file>]";

$interval = shift @ARGV;

die $usage if (!defined($interval));

$avail_rew = 0;
$avail_cycles = 0;
for (;;)
  {
    if ($interval <= 0 || $avail_cycles < $interval) {
      # read in more
      $_ = <>;
      last if (!defined($_));
      s/\#.*//;
      next if (not /\s*([-e\d\.]+)\s*([-e\d.]+)/);
      $cycles = $1;
      $rew = $2;
      #print "read $avail_cycles $avail_rew $cycles $rew\n";
      $avail_rew = ($avail_cycles * $avail_rew + $cycles * $rew) / ($avail_cycles + $cycles);
      $avail_cycles += $cycles;
    } elsif ($interval > 0) {
      print "$interval $avail_rew\n";
      $avail_cycles -= $interval;
    }
}

print "$avail_cycles $avail_rew\n" if ($avail_cycles);
