#!/usr/local/bin/perl5 -w

# This script reads a policy and an action map file and compares them
# outputs number of rows where policy action is in the action map and how
# many where it is not

# I shoudl really do this with the coach!

# @policy is a list of characters representing moves
# @actmap is a list of references to lists

$policyfn = shift @ARGV;
$actmapfn = shift @ARGV;

die "usage: $0 <policyfn> <actmapfn>" if (!defined($policyfn) || !defined($actmapfn));

# %acthash makes characters to number (policy uses characters, act map numbers). Sigh
$acthash{'X'} = 0;
$acthash{'N'} = 1;
$acthash{'S'} = 2;
$acthash{'E'} = 3;
$acthash{'W'} = 4;

# read the policy file into @policy
open (FH, "<$policyfn") || die "Could not open policy file '$policyfn': $!";
$_ = <FH>; # skip the first line
@policy = ();
while (<FH>)
  {
    ($idx, $val) = split;
    die "Weird idx: $idx" if ($idx != @policy);
    die "Bad action: $val" if (not exists $acthash{$val});
    push @policy, $acthash{$val};
  }
close (FH);

open (FH, "<$actmapfn") || die "Could not open action map file '$actmapfn': $!";
$_ = <FH>; # skip the first line
while (<FH>)
  {
    $list = [];
    (undef, @$list) = split;
    push @actmap, $list;
  }

die "Weird sizes: @policy @actmap" if (@policy != @actmap);

$inmap = 0;
$notinmap = 0;
for ($idx = 0; $idx < @policy; $idx++)
  {
    if (is_num_in_list($policy[$idx], @{$actmap[$idx]}))
      {
	$inmap++;
      }
    else
      {
	$notinmap++;
      }
  }

print <<EOF;
    In map: $inmap
Not in map: $notinmap
EOF

# returns 0 or 1
sub is_num_in_list
  {
    my ($val, @list) = @_;
    my ($x);
    foreach $x (@list) {
      return 1 if ($val == $x);
    }
    return 0;
  }
