#!/usr/local/bin/perl5 -w

# Reads in a final advice file and counts how many pieces of advice there are


$ARGV[0] = '-' if (@ARGV == 0);

foreach $fn (@ARGV) {

  open (FH, "<$fn") || die "Could not open input file '$fn': $!";

  $total = 0;
  # skip the first line
  $_ = <FH>;
  while (<FH>) {
    chomp;
    s/\#.*//;
    next if (/^\s*$/);
    (undef, $cnt, undef) = split;
    $total += $cnt;
  }

  close FH;

  print "$fn: $total\n";
}

