#!/usr/local/bin/perl5 -w

# uses gnuplot to make a plot of a qlearn_action_compare_actmap.data file generated by
# the action compare actmap mode in BaseQLearnBehavior.

# if outfn is missing, the datafn is used with any trailing .data deleted and .eps added
$usage = "$0 <datafn> <title> [<outfn>]";

$datafn= shift @ARGV;
$title = shift @ARGV;
$outfn = shift @ARGV;

die $usage if (not (defined($datafn)));

$title  = $datafn if (!defined($title));
if (!defined($outfn))
  {
    $outfn = $datafn;
    $outfn =~ s/\.data$//;
    $outfn .= '.eps';
  }

open (GPPROC, "|gnuplot") || die "Could not open gnuplot process";

print GPPROC <<EOF;
set term postscript eps 
set output '$outfn'

set nokey
set xlabel 'Time'
set ylabel '% of recommended actions in actmap'
set yrange [0:0.25]

set title '$title'
plot '$datafn' using (\$1/10):((\$2<50) ? 1/0 : \$3) with lines


EOF

