#!/usr/local/bin/perl5 -w

# uses gnuplot to make a plot of a reward data file

# if outfn is missing, the datafn is used with any trailing .data deleted and .eps added
$usage = "$0 <datafn> <title> [<outfn>]";


$datafn= shift @ARGV;
$title = shift @ARGV;
$outfn = shift @ARGV;

die $usage if (not (defined($datafn)));

$title  = $datafn if (!defined($title));
if (!defined($outfn))
  {
    $outfn = $datafn;
    $outfn =~ s/\.data$//;
    $outfn .= '.eps';
  }

open (GPPROC, "|gnuplot") || die "Could not open gnuplot process";

print GPPROC <<EOF;
set term postscript eps 
set output '$outfn'

set nokey
set xlabel 'Time Segment'
set ylabel 'Value of Learned Policy'

set title '$title'
plot '$datafn' using column(-1):(\$2*10) with linespoints, \\
     f(x)=1.72562411679764*10, f(x) notitle


EOF

