/* A behavior to provide advice to execute a fixed policy */

#ifndef _ADVISE_FIXED_BEHAVIOR_H_
#define _ADVICE_FIXED_BEHAVIOR_H_

#include "Behavior.hpp"
#include "Policy.hpp"

//The behavior takes over responsibility for the memory here
class AdviseFixedBehavior : public Behavior
{
public:
  AdviseFixedBehavior(spadesalib::AgentCommInterface* pacs, const char* policy_fn);
  AdviseFixedBehavior(spadesalib::AgentCommInterface* pacs, Policy* p);
  ~AdviseFixedBehavior();
  
  void respondSense(Behavior::SenseType st);
  bool initialize();

  Policy* getPolicy() const { return ppolicy; }
  void forgetPolicy() { ppolicy = NULL; }

private:
  Policy* ppolicy;
};


#endif
