/* A behavior to provide advice to execute a fixed policy */

#ifndef _ADVISE_FIXED_BY_ACTMAP_BEHAVIOR_H_
#define _ADVICE_FIXED_BY_ACTMAP_BEHAVIOR_H_

#include "Behavior.hpp"
#include "ActionSubsetMap.hpp"

//The behavior takes over responsibility for the memory here
// The act maps are queried in the order which they are added. If there is an action
// in the map for the given state, all actions in the map are chosen between
// if we run out of act maps, it's an error
class AdviseFixedByActMapBehavior : public Behavior
{
public:
  AdviseFixedByActMapBehavior(spadesalib::AgentCommInterface* pacs);
  ~AdviseFixedByActMapBehavior();
  
  void respondSense(Behavior::SenseType st);
  bool initialize();

  void addActMap(ActionSubsetMap* m) 
  { v_actmap.push_back(m); }

private:
  typedef std::vector<ActionSubsetMap*> VActMap;
  VActMap v_actmap;
};


#endif
