/* A behavior to execute coach q learning (my new technique) */

#ifndef _COACH_QLEARN_BEHAVIOR_H_
#define _COACH_QLEARN_BEHAVIOR_H_

#include <string>
#include "BaseQLearnBehavior.hpp"
#include "QTable.hpp"
#include "ActionSubsetMap.hpp"

//The behavior takes over responsibility for the memory here
class CoachQLearnBehavior : public BaseQLearnBehavior
{
public:
  CoachQLearnBehavior(spadesalib::AgentCommInterface* pacs,
		      float gamma,
		      explore_t exp, float alpha_explore, float boltzmann_constant,
		      const char* enable_map_fn);
  ~CoachQLearnBehavior();

  void respondSenseQLearn(Behavior::SenseType st);
  bool initialize();

private:
  void coachUpdateQValue();
  void sendAdvisedAction();

  ActionSubsetMap enable_map;

  bool advised_last_cycle;
};


#endif
