/* this little class helps with the logging */

#ifndef _PREDATORTAGFUNCTION_H_
#define _PREDATORTAGFUNCTION_H_

#include <string>
#include "Logger.hpp"

class TimeTagger
{
public:
  virtual std::string getTimeTag() = 0;
};


class CoachTagFunction
  : public spades::TagFunction
{
public:
  CoachTagFunction () : pTimeTagger(NULL) { }
  ~CoachTagFunction () { if (pTimeTagger) delete pTimeTagger; }

  std::string getTag (int level) const { return "TAGERROR"; }
  std::string getTag (int level, const std::string& channel_name) const
  {
    std::string s("[" + channel_name + "]");
    s.insert (s.end (), level / 10, '-');
    return (pTimeTagger ? pTimeTagger->getTimeTag() : std::string("")) + ' ' + s;
  }
  std::string getErrorTag (int level) const
  { return (pTimeTagger ? pTimeTagger->getTimeTag() : std::string("")) +
      (level == 0 ? "CoachError: " : ("CoachWarning[" + spades::toString(level) + "]: ")); }

  void setTimeTagger(TimeTagger* p) { pTimeTagger = p; }
  
private:
  TimeTagger* pTimeTagger;
};

#endif
