/* a state aciton advisoing behavior that picks a set of states to advise about each time */

#ifndef _OPTQ_COACH_SA_BEHAVIOR_H_
#define _OPTQ_COACH_SA_BEHAVIOR_H_

#include "BaseCoachSABehavior.hpp"
#include "QTableFlat.hpp"

class OptQCoachSABehavior : public BaseCoachSABehavior
{
public:
  OptQCoachSABehavior(spadesalib::AgentCommInterface* pacs,
		      float gamma,
		      explore_t exp, float alpha_explore, float boltzmann_constant,
		      const char* enable_map_fn,
		      const char* opt_qtable_fn);
  ~OptQCoachSABehavior();
  
  bool initialize();
  void respondSenseSA(Behavior::SenseType st);

  //this is the function which is called when it is time for more advice
  void getStateActionAdvice(int max_num_to_send, vec_sa_advice_t& v);

private:

  //takes the last state and agent action and updates our internal structure
  void updateFromAgentAction(entityid_t id);
  //sees if the agent did something we have advised them in the past
  void checkForQUpdate(entityid_t id);

  QTableFlat qt_opt;

  typedef std::vector<float> vec_state_value_t;
  //stored MeanSummary of opt action value - observed action value
  typedef std::vector<spades::MeanSummary> vec_agent_response_t;

  vec_state_value_t    vec_state_value;
  vec_agent_response_t vec_agent_response;
  
};



#endif
