/* A behavior to execute q-learning with coach involvement */

#ifndef _QLEARN_WCOACH_BEHAVIOR_H_
#define _QLEARN_WCOACH_BEHAVIOR_H_

#include <string>
#include "BaseQLearnBehavior.hpp"
#include "QTable.hpp"
#include "ActionSubsetMap.hpp"

//The behavior takes over responsibility for the memory here
class QLearnWCoachBehavior : public BaseQLearnBehavior
{
public:
  //the disable_map_fn can be empty to indicate no disabled actions
  QLearnWCoachBehavior(spadesalib::AgentCommInterface* pacs,
		       float gamma,
		       explore_t exp, float alpha_explore, float boltzmann_constant,
		       float coach_prob, bool random_on_advised_disable,
		       const char* disable_map_fn);
  ~QLearnWCoachBehavior();

  void respondSenseQLearn(Behavior::SenseType st);
  bool initialize();

private:

  float coach_prob; //the probability we listen to the coach
  bool random_on_advised_disable;
  
};


#endif
