/* A behavior to execute simple q-learning (no coach involvement) */


#include "SimpleQLearnBehavior.hpp"
#include "Logger.hpp"

using namespace std;
using namespace spades;
using namespace spadesalib;

SimpleQLearnBehavior::SimpleQLearnBehavior(AgentCommInterface* pacs, float gamma,
					   explore_t exp,
					   float alpha_explore, float boltzmann_constant,
					   const char* disable_map_fn)
  : BaseQLearnBehavior(pacs, gamma, exp, alpha_explore, boltzmann_constant, disable_map_fn)
{
}


SimpleQLearnBehavior::~SimpleQLearnBehavior()
{
}

  
void
SimpleQLearnBehavior::respondSenseQLearn(Behavior::SenseType st)
{
  if (st == ST_State)
    {
      actionlog(20) << "SimpleQLearnBehavior: responding and updating Q" << ende;
      updateQValue();
      basic_move_t action;
      action = (basic_move_t)qtable.getAct(exp_type, getCurrState().flatVal(), alpha_explore, boltzmann_constant);
      actionlog(20) << "SimpleQLearnBehavior: sending action: " << action << ende;
      sendMove(action);
      setLastAction(action);
      stateSenseUpdate();
    }
  else
    {
      errorlog << "SimpleQLearnBehavior: I can't handle anything but ST_State" << ende;
    }
}


bool
SimpleQLearnBehavior::initialize()
{
  if (!BaseQLearnBehavior::initialize())
    return false;
  return true;
}


