/* a behavior based on BaseQLearnCSABehavior that uses advice from the coach
   with a given probability if it exists, and follows the given exploration mode
   otherwise */

#ifndef _SIMPLE_QLEARN_CSA_BEHAVIOR_H_
#define _SIMPLE_QLEARN_CSA_BEHAVIOR_H_

#include <string>
#include "BaseQLearnCSABehavior.hpp"
#include "QTable.hpp"
#include "ActionSubsetMap.hpp"

//The behavior takes over responsibility for the memory here
class SimpleQLearnCSABehavior
  : public BaseQLearnCSABehavior
{
public:
  //the disable_map_fn can be empty to indicate no disabled actions
  SimpleQLearnCSABehavior(spadesalib::AgentCommInterface* pacs,
			  float gamma,
			  explore_t exp, float alpha_explore, float boltzmann_constant,
			  float coach_prob, const char* disable_map_fn);
  ~SimpleQLearnCSABehavior();

  void respondSenseCSA(Behavior::SenseType st);
  bool initialize();

private:
  void respondWithAction();
  
  float coach_prob; //the probability we listen to the coach
  ActionSubsetMap disable_map;
};


#endif
