/* A behavior to just query the coach and do what it says */

#include "StrictCoachReqBehavior.hpp"
#include "Logger.hpp"

using namespace spades;
using namespace spadesalib;

StrictCoachReqBehavior::StrictCoachReqBehavior(AgentCommInterface* pacs)
  : Behavior(pacs)
{
}

StrictCoachReqBehavior::~StrictCoachReqBehavior()
{
}

  
void
StrictCoachReqBehavior::respondSense(Behavior::SenseType st)
{
  switch (st)
    {
    case ST_None:
      errorlog << "I should get ST_None" << ende;
      break;
    case ST_TimeNotify:
      //do nothing, we never request time notifies
      break;
    case ST_State:
      //just request an action from the coach
      sendCoachRequest();
      break;
    case ST_Comm:
      if (getCommType() == CT_ActionAdvice)
	{
	  sendMove(getCommActionAdvice());
	}
      else
	{
	  errorlog << "I don't handle comms other than CT_ActionAdvice: " << getCommType() << ende;
	}
      break;
    default:
      errorlog << "I don't understand sense type: " << st << ende;
      break;
    }
}


bool
StrictCoachReqBehavior::initialize()
{
  return true;
}


