/* This is an act event to send a communication to another agent */

#ifndef _COMM_ACT_EVENT_H_
#define _COMM_ACT_EVENT_H_

#include <vector>
#include "ActEvent.hpp"
#include "PPSharedTypes.hpp"

class PredPreyWorld; //defined in PredPreyWorld.hpp

class CommActEvent : public spades::ActEvent
{
public:
  CommActEvent (spades::SimTime t, spades::AgentID a, entityid_t sender,
		const char* msg, unsigned msglen);
  ~CommActEvent();

  void addReceiver(spades::AgentID a);
  
  void print (std::ostream & o) const;

protected:
  //this is how the world model realizes the event
  bool realizeEventWorldModel(spades::WorldModel* pWM);
  
private:
  //we store this as null-terminated
  entityid_t sender;
  char* msg;

  typedef std::vector<spades::AgentID> recv_list_t;
  recv_list_t vReceivers;
};





#endif
