/* Create an inform event to tell agents of other agent actions */

#include <strstream>
#include "CreateActionInformEvent.hpp"
#include "SenseEvent.hpp"
#include "PredPreyWorld.hpp"

using namespace spades;
using namespace std;

CreateActionInformEvent::CreateActionInformEvent (spades::SimTime t, spades::AgentID a,
						  entityid_t eid, basic_move_t m)
  : CreateSenseEvent(t, a), eid(eid), action(m)
{
}


void
CreateActionInformEvent::print (std::ostream & o) const
{
  o << "CreateActionInformEvent(t:" << getTime()
    << ", a:" << getAgent()
    << ", eid:" << eid
    << ", act:" << action
    << ")";
}


//from CreateSenseEvent
spades::SenseEvent*
CreateActionInformEvent::createSense(spades::WorldModel* p)
{
  //No sense latency!
  SimTime arrive_time = getTime();

  ostrstream o;

  o << "(action " << eid << " " << action << ")" << ends;
  
  //this is a not thinking sensation!
  SenseEvent* pE = new SenseEvent(TT_Not, getTime(), arrive_time, getAgent());

  DataArray d(o);
  pE->setData(d);
  
  //note that we do not unfreeze ostrstream since DataArray took it

  return pE;
}

  


