/* Create an inform event to tell agents of capture */

#include <strstream>
#include "CreateCaptureInformEvent.hpp"
#include "SenseEvent.hpp"
#include "PredPreyWorld.hpp"

using namespace spades;
using namespace std;

CreateCaptureInformEvent::CreateCaptureInformEvent (spades::SimTime t, spades::AgentID a,
						    entityid_t eid_cap)
  : CreateSenseEvent(t, a), captured_agent(eid_cap)
{
}


void
CreateCaptureInformEvent::print (std::ostream & o) const
{
  o << "CreateCaptureInformEvent(t:" << getTime()
    << ", a:" << getAgent()
    << ", cap:" << captured_agent
    << ")";
}


//from CreateSenseEvent
spades::SenseEvent*
CreateCaptureInformEvent::createSense(spades::WorldModel* p)
{
  //No sense latency!
  SimTime arrive_time = getTime();

  ostrstream o;

  o << "(capture " << captured_agent << ")" << ends;
  
  //this is a not thinking sensation!
  SenseEvent* pE = new SenseEvent(TT_Not, getTime(), arrive_time, getAgent());

  DataArray d(o);
  pE->setData(d);
  
  //note that we do not unfreeze ostrstream since DataArray took it

  return pE;
}

  


