/* Create an inform event to tell agents of reward */

#include <strstream>
#include "CreateRewardInformEvent.hpp"
#include "SenseEvent.hpp"
#include "PredPreyWorld.hpp"

using namespace spades;
using namespace std;

CreateRewardInformEvent::CreateRewardInformEvent (spades::SimTime t, spades::AgentID a, int r)
  : CreateSenseEvent(t, a), reward(r)
{
}


void
CreateRewardInformEvent::print (std::ostream & o) const
{
  o << "CreateRewardInformEvent(t:" << getTime()
    << ", a:" << getAgent()
    << ", r:" << reward
    << ")";
}


//from CreateSenseEvent
spades::SenseEvent*
CreateRewardInformEvent::createSense(spades::WorldModel* p)
{
  //No sense latency!
  SimTime arrive_time = getTime();

  ostrstream o;

  o << "(reward " << reward << ")" << ends;
  
  //this is a not thinking sensation!
  SenseEvent* pE = new SenseEvent(TT_Not, getTime(), arrive_time, getAgent());

  DataArray d(o);
  pE->setData(d);
  
  //note that we do not unfreeze ostrstream since DataArray took it

  return pE;
}

  


