/* This class is the basic info for an entity in the world, i.e. a agent who
   has a position in the world
   This will not include the coach */

#include <cstring>
#include "Entity.hpp"
#include "Logger.hpp"
#include "random.hpp"
#include "PredPreyParam.hpp"

using namespace spades;
using namespace std;

inline int max(int a, int b)
{ return (a > b) ? a : b; } 
inline int min(int a, int b)
{ return (a < b) ? a : b; } 
  
/*****************************************************************************/

void
Entity::applyMove()
{
  switch (next_move)
    {
    case BM_None:
      break;
    case BM_North:
      if (PredPreyParam::instance()->getWraparound())
	pos.y = (pos.y+1) % PredPreyParam::instance()->getYSize();
      else
	pos.y = min(pos.y+1, PredPreyParam::instance()->getYSize() - 1);
      break;
    case BM_South:
      if (PredPreyParam::instance()->getWraparound())
	pos.y = (pos.y-1+PredPreyParam::instance()->getYSize()) % PredPreyParam::instance()->getYSize();
      else
	pos.y = max(pos.y-1, 0);
      break;
    case BM_East:
      if (PredPreyParam::instance()->getWraparound())
	pos.x = (pos.x+1) % PredPreyParam::instance()->getXSize();
      else
	pos.x = min(pos.x+1, PredPreyParam::instance()->getXSize() - 1);
      break;
    case BM_West:
      if (PredPreyParam::instance()->getWraparound())
	pos.x = (pos.x-1+PredPreyParam::instance()->getXSize()) % PredPreyParam::instance()->getXSize();
      else
	pos.x = max(pos.x-1, 0);
      break;
    default:
      errorlog << "What is next_move? " << next_move << ende;
      break;
    }
  
  next_move = BM_None;
}

