/* a simple class to capture the world state at a given time */

#ifndef _WORLD_STATE_H_
#define _WORLD_STATE_H_

#include <vector>
#include <iostream>

using namespace std;

class EntityInfo
{
public:
  EntityInfo() : num(-1), x_pos(0), y_pos(0) {}
  ~EntityInfo() {}

  friend istream& operator>>(istream& in, EntityInfo& e);

  int num;
  int x_pos;
  int y_pos;
};


class WorldState
{
public:
  WorldState();
  ~WorldState();

  void clear();
  
  void drawOnNCurses();

  friend istream& operator>>(istream& in, WorldState& ws);

  static bool readHeaderInfo(istream& in);
  
private:

  int time;
  vector<EntityInfo> vPred;
  vector<EntityInfo> vPrey;

  static int x_size;
  static int y_size;
  
};


#endif
